#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <pthread.h>
#include "func_extern.h"
#include "control.h"
#include "irs_ts_ws.h"
#include "pwm_enc.h"
#include "uss.h"

int circle_adj(int ang_adj, int search_end, int target_post){
	int radius=0;
	if(search_end > 0) radius=circle_radious;
	else if(post.got_post[target_post-1]==1) radius=circle_radious;
	else radius=DIS_BACK+MCENTER_TS_DIS+post_diameter/2;

	if(rotate_dir_select==2){
		lqr_rotate(90, 90*20);
		usleep(SLEEPTIME_MAIN);
		lqr_circle(-radius, -(ang_adj), (ang_adj)*40);	// 'circle_radious' is defined in 'control.h'
		usleep(SLEEPTIME_MAIN);
	}
	if(rotate_dir_select==1){
		lqr_rotate(90, 90*20);
		usleep(SLEEPTIME_MAIN);
		lqr_circle(-radius, (ang_adj), (ang_adj)*40);
		usleep(SLEEPTIME_MAIN);
	}
	return 0;
}
