/*
	Definition major parameters of control program.
	Definition struct variables.
	Declaration of variablae types.
*/
#define POST_NUM 4 		/* total post numbers */ 
/* movement paramter */
#define circle_radious 330	/* circle diameter of going arround a post */
#define post_diameter 200	/* post diameter */
#define PWM_ENC_PERIOD 20	/* RT tsak period of pwm_enc_module2 */
#define FOWARD_DIS 100 		/* Distance to move to the post in circle_position */
/* USS measurment parmeter */
#define USS_MAX 1300		/* POST distace maxmimum */
#define USS_MIN 300 		/* POST distace minimum */
#define MCENTER_USS3_DIS 145		/* Distance between MIRS center and USS3 */
#define MCENTER_USS12_DIS 150		/* Distance between MIRS center and USS1,2 */
#define USS12_DIFF  0		/* USS Diffrence = USS1 - USS2  */
#define USS_CORRECT -30 /* Difference of USS data from correct distance */

// tuning parameter 
#define POST_ANG_DIFF	-14 /* POST angle diffrence in post_search */
#define AROUND_ANG      (360+7) /* Rotation Angle around post in post_circle */

// MIRS0604's original DEFINE
#define SLEEPTIME_MAIN 300000	/* sleep time of the main function */
#define MCENTER_TS_DIS 170	/* Distance between MIRS center and TS */
#define DIS_FORWARD 1000 
#define DIS_BACK 100
#define READ_TIME 1000000
#define TS_POS 0	/* position of TS */

// declaration of pthead type
pthread_t uss_task;
pthread_t uss_task2;
pthread_t irs_code_task;
pthread_t irs_ts_ws_task;
pthread_t encoder_task;
pthread_attr_t attr_encoder;
pthread_attr_t attr_irs_ts_ws;
pthread_attr_t attr_uss;

/*
        Definition of stuct variable of post and post_tmp
        variable "post" has data of sevral post information. The data will be
        input during first call of post_search().
        variable "post_tmp" has data of post distance and angle for
        correct_center(). The data will be input during the call of post_search()
        calling after move_center().
*/
struct post{
        int ang[10]; /* post angle */
        int dis[10]; /* distance between post-center and mirs-center */
        int code[10]; /* IRS code of post */
        int got_post[10]; /* flag of post */
        int got_code; /* IRS code number have been got */
        int got_number; /* numbers of posts have been got */
        int number; /* found post numbers */
};
struct post_tmp{
        int ang[10]; /* post angel */
        int dis[10]; /* distance between post-center and mirs-center */
	int number;  /* found post numbers */
};
struct post_jammer{
	int ang;
	int dis;
	int ang1x;
	int number;
};
struct p2p_data{
	int ang1;
	int dis1;
	int ang;
	int dis;
	int ang12;
	int ang_adj;
	int dis_adj;
};

struct sched_param sched_param;
struct count_data count;
struct uss_msg_struct uss_msg;
struct post post;
struct post_tmp post_tmp;
struct post_jammer jammer;
struct p2p_data p2p_data;

// alw and arw are rotation distance of left and right tire, respectively.
float alw,arw;

int fd0, fd1, fd2, fd3, fd4, fd5, fd6, fd7, ctl;

char irs[4],ts[4],ws[4];       /*tuika*/

int irs_flag,ts_flag,ws_flag;      /*tuika*/
int uss_data;
int target_code;
int return_dist;
int cor_ang;
int uss12;
int angmax;	/* MIRS0604 original */
int triangle;
int gamecount;
int rotate_dir_select;	/* determine rotate direction. used in post2post() and main(). */
