//circle position 
#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <pthread.h>
#include "func_extern.h"
#include "control.h"
#include "irs_ts_ws.h"
#include "pwm_enc.h"
#include "uss.h"

#define DIFF 10

void circle_position(){
	int uss,uss1,uss2;
	int diff = 100;
	
	//correct_direction2	
	correct_direction2();

	usleep(5000);
	do{
		uss1 = uss_get(1);
		usleep(2000);
		uss2 = uss_get(2);
		usleep(2000);
		uss = (uss1+uss2)/2 + USS_CORRECT;
		//calculate difference
		diff = circle_radious-(uss+post_diameter/2+MCENTER_USS12_DIS);
		diff = diff + FOWARD_DIS;
		if(diff>0){//too close to the post
			if(DIFF<abs(diff)){
				//back
				printf("back  diff=%d\n",diff);
				lqr_straight(-30,500);
				//lqr_straight(-diff,abs(diff)*5);
			}
		}else{//too far from the post
			if(DIFF<abs(diff)){
				//foward
				printf("foward diff=%d\n",diff);
				lqr_straight(25,500);
				//lqr_straight(-diff,abs(diff)*5);
			}
		}
	}while(DIFF<=abs(diff));
	
	//correct_direction2	
	correct_direction2();

	//printf("move foward\n");
	//lqr_straight(FOWARD_DIS,1000);
	printf("circle_position end\n");
}
