#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <pthread.h>
#include "func_extern.h"
#include "control.h"
#include "irs_ts_ws.h"
#include "pwm_enc.h"
#include "uss.h"

int move_centerpos(int dis){
	int dis_moved=0,tmp_left=0,tmp_right=0,error=0;
	printf("Move to center\n");

	pwm_enco_start(10);
	usleep(40000);
	pwm_lqr_straight(dis,dis*5);
	usleep(40000);
	count.br=0;
	tmp_left=count.left_sum;
	tmp_right=count.right_sum;
	while(1){
		printf("%d %d\n",count.left_sum,count.right_sum);
		if(count.left_sum==tmp_left && count.right_sum==tmp_right){
			error++;
		}else{
			tmp_left=count.left_sum;
			tmp_right=count.right_sum;
			error=0;
		}
		if(error>40 || count.br==1) break;
		usleep(50000);
	}
	//tire stop
	pwm_both_data(0,0);
	usleep(40000);
	//encoder task stop
	pwm_enco_stop();
	usleep(40000);
	usleep(500000);

	if(error>40){
		dis_moved=(count.left_sum+count.right_sum) * diameter * pi / (2 * cpr * gear);
		printf("dis_moved = %d\n",dis_moved);
		dis=dis-dis_moved-500;
		if(dis<0) dis=0;
		lqr_straight(-200,200*6);
		usleep(300000);
		correct_direction1(0);
		usleep(300000);
		moveOnCircleRadius();
		usleep(300000);
		lqr_rotate(90,90*20);
		usleep(300000);
		lqr_circle(-circle_radious,AROUND_ANG/2,40*AROUND_ANG/2);
		usleep(300000);
		lqr_rotate(90,90*20);
		usleep(300000);
		lqr_straight(dis,dis*4);
		usleep(300000);
	}
	return 0;
}
