#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <pthread.h>
#include "func_extern.h"
#include "control.h"
#include "irs_ts_ws.h"
#include "pwm_enc.h"
#include "uss.h"

int post_code_judge(){
	if(ws[3]=='0' && ws[2]=='0' && ws[1]=='0' && ws[0]=='0')
		return 5;
	else if(ws[3]=='1' && ws[2]=='0' && ws[1]=='0' && ws[0]=='0')
		return 4;
	else if(ws[3]=='1' && ws[2]=='1' && ws[1]=='0' && ws[0]=='0')
		return 3;
	else if(ws[3]=='1' && ws[2]=='1' && ws[1]=='1' && ws[0]=='0')
		return 2;
	else if(ws[3]=='1' && ws[2]=='1' && ws[1]=='1' && ws[0]=='1')
		return 1;
	else
		return -1;
}
	

int post_code_get(int num){
	int i,tmp_left=0,tmp_right=0,error=0;
	printf("post_code_get() is called.\n");

	for(i=0;i<3;i++){
		pwm_enco_start(10);
		usleep(40000);
		pwm_lqr_straight(DIS_FORWARD,DIS_FORWARD*20);
		usleep(40000);
		tmp_left=count.left_sum;
		tmp_right=count.right_sum;
		while(1){
			printf("%d %d\n",count.left_sum,count.right_sum);
			if(count.left_sum==tmp_left && count.right_sum==tmp_right){
				error++;
			}else{
				tmp_left=count.left_sum;
				tmp_right=count.right_sum;
				error=0;
			}
			if(ts[TS_POS]=='1' || error>60) break;
			usleep(50000);
		}
		//tire stop
		pwm_both_data(0,0);
		usleep(40000);
		//encoder task stop
		pwm_enco_stop();
		usleep(40000);
		usleep(500000);
		if(ts[TS_POS]=='1') break;
		if(error>60){
			i=-1;
			error=0;
			lqr_straight(-200,200*6);
			usleep(300000);
			correct_direction1(0);
			usleep(300000);
		}
	}

	while(1){
		post.code[num]=post_code_judge();
		usleep(200000);
		if(post.code[num]==post_code_judge() && post.code[num]!=-1) break;
		usleep(20000);
	}

	printf("##### post code : %d #####\n",post.code[num]);

	if(post.code[num]==post.got_number+1){
		lqr_straight(-40,1000);
	}else{
		lqr_straight(-DIS_BACK,DIS_BACK*6);
	}
	usleep(40000);

	printf("post_code_get() finished.\n");
	return 0;
}
