#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <pthread.h>
#include "func_extern.h"
#include "control.h"
#include "irs_ts_ws.h"
#include "pwm_enc.h"
#include "uss.h"

int datawrite_angdis(void){
	FILE *fp;
	printf("##### write post data #####\n");
	if ((fp = fopen("post_angdis.dat", "wb")) == NULL) {
		printf("file open error!!\n");
		return -1;
	}
	fwrite(post.ang,sizeof(post.ang),1,fp);
	fwrite(post.dis,sizeof(post.dis),1,fp);
	fwrite(&post.number,sizeof(post.number),1,fp);
	fclose(fp);
	return 0;
}

int datawrite_code(void){
	FILE *fp;
	printf("##### write post data #####\n");
	if ((fp = fopen("post_code.dat", "wb")) == NULL) {
		printf("file open error!!\n");
		return -1;
	}
	fwrite(post.code,sizeof(post.code),1,fp);
	fclose(fp);
	return 0;
}

int dataread(void){
	int i;
	FILE *fp1,*fp2;
	printf("##### read post data #####\n");
	if ((fp1 = fopen("post_angdis.dat", "rb")) == NULL) {
		printf("file open error!!\n");
		return -1;
	}
	if ((fp2 = fopen("post_code.dat", "rb")) == NULL) {
		printf("file open error!!\n");
		return -1;
	}
	fread(post.ang,sizeof(post.ang),1,fp1);
	fread(post.dis,sizeof(post.dis),1,fp1);
	fread(&post.number,sizeof(post.number),1,fp1);
	fread(post.code,sizeof(post.code),1,fp2);
	for(i=0;i<POST_NUM;i++){
		if(post.code[i]==0) break;
	}
		
	fclose(fp1);
	fclose(fp2);
	return (i+1);
}
