//approach
/*
This program is based on post_approach of MIRSSTND V1.1 and approach.c of MIRS0401
        2005/5/24
	modified by S. Ushimaru
*/
#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <pthread.h>
#include "func_extern.h"
#include "control.h"
#include "irs_ts_ws.h"
#include "pwm_enc.h"
#include "uss.h"

int post_approach(int target_post){

	int move_time,rotate_time;
	int angle, distance = 0; 
	int r_value=0;
	int p_flag=0;	

	//chage the post angle data between -180~180
	if(post.ang[target_post]<180){
		angle=post.ang[target_post];
	}else{
		angle=post.ang[target_post]-360;
	}
	printf("in approach func. approach angle = %d\n",angle);

     	//rotate at the center
	rotate_time=angle*20;
	lqr_rotate(angle,rotate_time);
	usleep(300000);
	printf("rotation end: correct_direction start \n");

	//start correct_direction1
	p_flag = correct_direction1(target_post);
	
	if(p_flag != -1){//there is post
	//determine the distace to go and move to the post
	distance=uss12 + USS_CORRECT - USS_MIN ;
	printf("in approach func. approach distance = %d\n",distance);
	move_time=distance*4;
	lqr_straight(distance,move_time);

	//exit(0);
       
	//move to the point of circe_radius
//	circle_position(); 
//	usleep(300000);

	correct_direction1(target_post);
	usleep(300000);

	//determine return distance	
	return_dist=post.dis[target_post]-circle_radious;

	//determine the return value
	r_value = 0;
	}else{//there is no post
		printf("There is no post!\n");
		r_value = 9999;
	}

	return r_value;
}
