#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <pthread.h>
#include <math.h>
#include "func_extern.h"
#include "control.h"
#include "irs_ts_ws.h"
#include "pwm_enc.h"
#include "uss.h"

int post_crash_check(int ang1,int dis1,int postnum_now,int postnum_next){
	int ang1x=0,phase_xxx=0;
	int ang_xxx2mirs=0,dis_xxx2mirs=0;
	int ang_xxx=0,dis_xxx=0;
	int ang_now2xxx=0,dis_now2xxx=0;
	int ang_now2next=0,dis_now2next=0;
	int i,jammer_count=0;
	jammer.dis=9999,jammer.ang=0,jammer.ang1x=0,jammer.number=-1;

	for(i=0;i<post.number;i++){
		/* calc : present <=> others */
		if(i!=postnum_now && i!=postnum_next){
			ang_xxx=post.ang[i];
			dis_xxx=post.dis[i];
			if(abs(ang1-ang_now2xxx)==180){
				dis_now2xxx=dis1+dis_xxx-p2p_data.dis_adj;
				ang_now2xxx=180;
				ang1x=180;
			}else{
				if(abs(ang1-ang_now2xxx)<180) ang1x=abs(ang1-ang_now2xxx);
				if(abs(ang1-ang_now2xxx)>180) ang1x=360-abs(ang1-ang_now2xxx);
				dis_now2xxx=sqrt(dis1*dis1+dis_xxx*dis_xxx-2*dis1*dis_xxx*cos(ang1x*M_PI/180.))-p2p_data.dis_adj;
				ang_now2xxx=180-asin(dis_xxx*sin(ang1x*M_PI/180.)/(dis_now2xxx+p2p_data.dis_adj))*180/M_PI;
			}
		}
		if(abs(ang_now2next - ang_now2xxx)<180)  phase_xxx=abs(ang_now2next - ang_now2xxx);
		if(abs(ang_now2next - ang_now2xxx)>=180) phase_xxx=360-abs(ang_now2next - ang_now2xxx);
		if(phase_xxx < 90 && dis_now2xxx < dis_now2next){
			dis_xxx2mirs=dis_now2xxx*sin(phase_xxx*M_PI/180.);
			if(dis_xxx2mirs < 35){
				jammer_count++;
				printf("No.%d is jammer!\n",i+1);
				if(dis_xxx2mirs<jammer.dis){
					jammer.dis=dis_xxx2mirs;
					jammer.ang=ang_xxx2mirs;
					jammer.ang1x=dis_xxx2mirs;
					jammer.number=i;
				}
			}
		}
	}
	printf("the number of the jammer-post(s) : %d\n",jammer_count);
	return jammer_count;
}
