#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <pthread.h>
#include "func_extern.h"
#include "control.h"
#include "irs_ts_ws.h"
#include "pwm_enc.h"
#include "uss.h"

int uss_get(int uss_no){

        uss_msg.command=1; /* 1 Shot Task */
        uss_msg.number = uss_no;
        write(ctl, &uss_msg, sizeof(uss_msg));

        usleep(30000);
        printf("uss_data %d\n",uss_data);
        return uss_data;
}

int main(void){
	int num,dis;
	printf("uss number : ");
	scanf("%d",&num);
	pthread_create(&uss_task,&attr_uss,&uss_read,(void *)1);
	while(1){
		dis=uss_get(num);
		usleep(500000);
	}
	pthread_cancel(uss_task);
	return 0;
}
